#define _GNU_SOURCE

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

int main(int argc, char* argv[]) {
	const char* old;
	static const char newp[] = "libvmusb.so";
	char* newenv;
	
	old = getenv("LD_PRELOAD");
	if (old) {
		asprintf(&newenv, "%s %s", old, newp);	
	} else {
		newenv = strdup(newp);
	}
	setenv("LD_PRELOAD", newenv, 1);
	free(newenv);
	asprintf(&newenv, "%s.bin", argv[0]);
	execv(newenv, argv);
	fprintf(stderr, "Cannot start %s: %s\n", newenv, strerror(errno));
	return 99;
}
