#ifndef __RNDIS_H__
#define __RNDIS_H__

#include "ndis.h"

#define REMOTE_NDIS_PACKET_MSG		0x00000001
#define REMOTE_NDIS_INITIALIZE_MSG	0x00000002
#define REMOTE_NDIS_INITIALIZE_CMPLT	0x80000002
#define REMOTE_NDIS_HALT_MSG		0x00000003
#define REMOTE_NDIS_QUERY_MSG		0x00000004
#define REMOTE_NDIS_QUERY_CMPLT		0x80000004
#define REMOTE_NDIS_SET_MSG		0x00000005
#define REMOTE_NDIS_SET_CMPLT		0x80000005
#define REMOTE_NDIS_RESET_MSG		0x00000006
#define REMOTE_NDIS_RESET_CMPLT		0x80000006
#define REMOTE_NDIS_INDICATE_STATUS_MSG	0x00000007
#define REMOTE_NDIS_KEEPALIVE_MSG	0x00000008
#define REMOTE_NDIS_KEEPALIVE_CMPLT	0x80000008

struct RNDIS_PACKET_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	DataOffset;
	u_int32_t	DataLength;
	u_int32_t	OOBDataOffset;
	u_int32_t	OOBDataLength;
	u_int32_t	NumOOBDataElements;
	u_int32_t	PerPacketInfoOffset;
	u_int32_t	PerPacketInfoLength;
	u_int32_t	VcHandle;
	u_int32_t	Reserved;
};

struct RNDIS_INITIALIZE_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	MajorVersion;
	u_int32_t	MinorVersion;
	u_int32_t	MaxTransferSize;
};

struct RNDIS_INITIALIZE_CMPLT {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Status;
	u_int32_t	MajorVersion;
	u_int32_t	MinorVersion;
	u_int32_t	DeviceFlags;
	u_int32_t	Medium;
	u_int32_t	MaxPacketsPerTransfer;
	u_int32_t	MaxTransferSize;
	u_int32_t	PacketAlignmentFactor;
	u_int32_t	AFListOffset;
	u_int32_t	AFListSize;
};

struct RNDIS_HALT_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
};

struct RNDIS_QUERY_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Oid;
	u_int32_t	InformationBufferLength;
	u_int32_t	InformationBufferOffset;
	u_int32_t	DeviceVcHandle;
};

struct RNDIS_QUERY_CMPLT {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Status;
	u_int32_t	InformationBufferLength;
	u_int32_t	InformationBufferOffset;
};

struct RNDIS_SET_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Oid;
	u_int32_t	InformationBufferLength;
	u_int32_t	InformationBufferOffset;
	u_int32_t	DeviceVcHandle;
};

struct RNDIS_SET_CMPLT {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Status;
};

struct RNDIS_RESET_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	Reserved;
};

struct RNDIS_RESET_CMPLT {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	Status;
	u_int32_t	AddressingReset;
};

struct RNDIS_INDICATE_STATUS_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	Status;
	u_int32_t	StatusBufferLength;
	u_int32_t	StatusBufferOffset;
};

struct RNDIS_KEEPALIVE_MSG {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
};

struct RNDIS_KEEPALIVE_CMPLT {
	u_int32_t	MessageType;
	u_int32_t	MessageLength;
	u_int32_t	RequestId;
	u_int32_t	Status;
};

struct Rndis_Diagnostic_Info {
	u_int32_t	DiagStatus;
	u_int32_t	ErrorOffset;
};

struct RNDIS_CONFIG_PARAMETER {
	u_int32_t	ParameterNameOffset;
	u_int32_t	ParameterNameLength;
	u_int32_t	ParameterType;
	u_int32_t	ParameterValueOffset;
	u_int32_t	ParameterValueLength;
};

#endif	/* __RNDIS_H__ */

