#ifndef __VMNET_DEVICE_H__
#define __VMNET_DEVICE_H__

#include <sys/types.h>
#include <net/if.h>

struct vmnetDevice {
	int fd;
	int ifver;
};

void
vmnetInit(struct vmnetDevice* dev);

int
vmnetIsConnected(const struct vmnetDevice* dev);

int
vmnetConnect(struct vmnetDevice* dev,
	     const char* fileName);

void
vmnetDisconnect(struct vmnetDevice* dev);

int
vmnetSetMACAddress(const struct vmnetDevice* dev,
		   const unsigned char mac[6]);

int
vmnetSetIFFlags(const struct vmnetDevice* dev,
		u_int32_t flags);

int
vmnetGetMACAddress(const struct vmnetDevice* dev,
		   unsigned char mac[6]);

static inline void
vmnetDestroy(struct vmnetDevice* dev)
{
	vmnetDisconnect(dev);
}

void
vmnetSendPacket(const struct vmnetDevice* dev,
		const void* data,
		size_t len);

#endif	/* __VMNET_DEVICE_H__ */
